#include <Windows.h>

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wc = { 0 };
    wc.lpfnWndProc = WndProc;
    wc.hInstance = hInstance;
    wc.hbrBackground = (HBRUSH)(COLOR_BACKGROUND);
    wc.lpszClassName = TEXT("MyWindowClass");

    if (!RegisterClass(&wc))
        return -1;

    HWND hWnd = CreateWindow(
        TEXT("MyWindowClass"), // 윈도우 클래스
        TEXT("Window Title"), // 윈도우 타이틀
        WS_OVERLAPPEDWINDOW, // 윈도우 스타일
        100, // 윈도우 위치 x
        100, // 윈도우 위치 y
        500, // 윈도우 너비
        500, // 윈도우 높이
        NULL,
        NULL,
        hInstance,
        NULL
    );

    if (!hWnd)
        return -1;
    ShowWindow(hWnd, nCmdShow);

    MSG msg = { 0 };
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (int)msg.wParam;
}