#include <Windows.h>

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);
HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text);
HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text);

HWND hWnd, text;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    hWnd = createWindow(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
    text = createText(hWnd, 10, 10, 100, 100, L"텍스트");

    MSG msg = { 0 };
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (int)msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    wchar_t wc[2];

    switch (message)
    {
    case WM_CHAR:
        wc[0] = (wchar_t)wParam;
        wc[1] = L'\0';
        SetWindowText(text, wc);
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wc = { 0 };
    wc.lpfnWndProc = WndProc;
    wc.hInstance = hInstance;
    wc.hbrBackground = (HBRUSH)(COLOR_BACKGROUND);
    wc.lpszClassName = TEXT("MyWindowClass");
    RegisterClass(&wc);

    HWND hWnd = CreateWindow(
        TEXT("MyWindowClass"), // 윈도우 클래스
        TEXT("Window Title"), // 윈도우 타이틀
        WS_OVERLAPPEDWINDOW, // 윈도우 스타일
        100, // 윈도우 위치 x
        100, // 윈도우 위치 y
        500, // 윈도우 너비
        500, // 윈도우 높이
        NULL,
        NULL,
        hInstance,
        NULL
    );
    ShowWindow(hWnd, nCmdShow);

    return hWnd;
}

HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text)
{
    HWND hWnd = CreateWindow(
        L"BUTTON",
        text, 
        WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
        x, 
        y,
        width,
        height,
        parent,
        NULL,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}

HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text)
{
    HWND hWnd = CreateWindow(
        L"STATIC",
        text,
        SS_CENTER | WS_CHILD,
        x,
        y,
        width,
        height,
        parent,
        NULL,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}