#include <Windows.h>
#include <windowsx.h>

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);
HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text, int id);
HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text);

HWND hWnd, text, button1, button2;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    hWnd = createWindow(hInstance, hPrevInstance, lpCmdLine, nCmdShow);
    text = createText(hWnd, 10, 10, 100, 30, L"0");
    button1 = createButton(hWnd, 120, 10, 100, 30, L"초기화", 1);
    button2 = createButton(hWnd, 240, 10, 100, 30, L"증가", 2);

    MSG msg = { 0 };
    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return (int)msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int cnt = 0;
    wchar_t wc[128];

    switch (message)
    {
    case WM_COMMAND:
        switch (LOWORD(wParam))
        {
        case 1:
            cnt = 0;
            wsprintf(wc, L"%d", cnt);
            SetWindowText(text, wc);
            break;
        case 2:
            cnt++;
            wsprintf(wc, L"%d", cnt);
            SetWindowText(text, wc);
            break;
        }
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

HWND createWindow(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wc = { 0 };
    wc.lpfnWndProc = WndProc;
    wc.hInstance = hInstance;
    wc.hbrBackground = (HBRUSH)(COLOR_BACKGROUND);
    wc.lpszClassName = TEXT("MyWindowClass");
    RegisterClass(&wc);

    HWND hWnd = CreateWindow(
        TEXT("MyWindowClass"), // 윈도우 클래스
        TEXT("Window Title"), // 윈도우 타이틀
        WS_OVERLAPPEDWINDOW, // 윈도우 스타일
        100, // 윈도우 위치 x
        100, // 윈도우 위치 y
        500, // 윈도우 너비
        500, // 윈도우 높이
        NULL,
        NULL,
        hInstance,
        NULL
    );
    ShowWindow(hWnd, nCmdShow);

    return hWnd;
}

HWND createButton(HWND parent, int x, int y, int width, int height, const wchar_t* text, int id)
{
    HWND hWnd = CreateWindow(
        L"BUTTON",
        text,
        WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
        x,
        y,
        width,
        height,
        parent,
        id,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}

HWND createText(HWND parent, int x, int y, int width, int height, const wchar_t* text)
{
    HWND hWnd = CreateWindow(
        L"STATIC",
        text,
        SS_CENTER | WS_CHILD,
        x,
        y,
        width,
        height,
        parent,
        NULL,
        (HINSTANCE)GetWindowLongPtr(parent, GWLP_HINSTANCE),
        NULL);
    ShowWindow(hWnd, 1);

    return hWnd;
}