#include <stdio.h>
#include <stdlib.h>

typedef struct node {
	int value;
	struct node* next;
} node;

typedef struct list {
	struct node* head;
	int size;
} list;

list* init();
void appendFirst(list* li, int value);
void removeFirst(list* li);

int main()
{
	list* li = init();
	
	appendFirst(li, 1);
	removeFirst(li);
	appendFirst(li, 2);
	appendFirst(li, 3);

	for (node* now = li->head; now; now = now->next)
		printf("%d\n", now->value);

	for (node* now = li->head; now;)
	{
		node* next = now->next;
		free(now);
		now = next;
	}
}

list* init()
{
	list* li = malloc(sizeof(list));
	li->head = NULL;
	li->size = 0;
	return li;
}

void appendFirst(list* li, int value)
{
	node* first = malloc(sizeof(node));
	node* second = li->head;

	first->value = value;
	first->next = second;
	li->head = first;
	li->size++;
}

void removeFirst(list* li)
{
	if (li->size > 0)
	{
		node* first = li->head->next;
		free(li->head);
		li->head = first;
		li->size--;
	}
}